//---------------------------------------------------------------------------
#ifndef GlobalH
#define GlobalH
#include <ShlObj.h>
#include <vcl\comctrls.hpp>
#include <assert.h>
#include <time.h>
#include "MsgBoxDlgs.h"
#include "view.h"
//---------------------------------------------------------------------------
#define AppMainForm Application->MainForm
#define AppProcessMessages() Application->ProcessMessages()
#define AppExeName Application->ExeName.UpperCase()
#define AppDir ExtractFilePath(AppExeName).LowerCase()
#define AppIni (ChangeFileExt(AppExeName,".ini"))
#define AppHelp (ChangeFileExt(AppExeName,".txt"))
#define AppQue (ChangeFileExt(AppExeName,".que"))
#define AppQueLck (AppQue+".lck")
#define ISDESIGNING (FileExists(ChangeFileExt(AppExeName,".dsk")))
#define s(s) AnsiString(s)
#define sm(m) ShowMessage(s(m))
#define MsgBoxHwnd(h,m,t,b) MessageBox(HWND(h),String(m).c_str(),String(t).c_str(),b)
#define MsgBox(m,t,b) MsgBoxHwnd(Application->MainForm->Handle,m,t,b)
#define MsgBoxTsk(m,t,b) MsgBoxHwnd(NULL,m,t,b|MB_TASKMODAL)
#define AddBS(dir) AddBackslash(dir)
#define RemBS(dir) RemoveBackslash(dir)

#define WM_SPENDTOKEN	WM_USER+1
//---------------------------------------------------------------------------
void __fastcall Snooze(int millisecs);
bool __fastcall ValidEAddress(AnsiString addr);
AnsiString __fastcall PadRight(AnsiString &string, int width);
TStrings* __fastcall TrimNullsBefore(TStrings *strings);
TStrings* __fastcall TrimNullsAfter(TStrings *strings);
TStrings* __fastcall TrimNullsStart(TStrings *strings);
TStrings* __fastcall TrimNullsEnd(TStrings *strings);
TStrings* __fastcall TrimNulls(TStrings *strings);
AnsiString __fastcall GetEAddress(AnsiString useridstr); // returns uid@server.com
AnsiString __fastcall UnixDateStr();
void __fastcall SaveToFileNoWrap(TRichEdit *Editor, AnsiString &FileName);
void __fastcall GetUnWrappedText(TRichEdit *Editor, TStrings *ToStrings);
void __fastcall SetRedraw(TWinControl *window, bool set);
TColor __fastcall GetColor16(int Index);
void __fastcall ClearString(AnsiString &str);
AnsiString __fastcall GetLastErrorStr();
bool DiskInDrive(char drive);
bool __fastcall SetRunOnce(const AnsiString Name, const AnsiString RunCmd);
void __fastcall MyBeep(WORD BeepType=MB_OK);
bool __fastcall DeleteDirectory(AnsiString &pathname);
HINSTANCE __fastcall ExploreFolder(AnsiString &strFolder);
HANDLE __fastcall Exec95(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
DWORD __fastcall ExecAndWait95(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
AnsiString __fastcall GetShortFileName(AnsiString &FileName);
AnsiString __fastcall GetWindowsDir();
AnsiString __fastcall GetTempDir();
AnsiString __fastcall GetTempFilename();
void __fastcall CopyToClipboard(TStrings *Text);
void __fastcall PasteFromClipboard(TStrings *Text);  // meno OR riched
void __fastcall PasteFromClipboard(TCustomMemo *Editor);
AnsiString __fastcall TextFromClipboard();
void __fastcall CenterDialog(TForm *CenteredForm, TComponent *MainForm=Application->MainForm);
AnsiString __fastcall GetToken(int pos, AnsiString &fromBuf, char *divider, char *def="");
AnsiString __fastcall GetParam(int pos, AnsiString &fromBuf, char *divider=",", char *def="");
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr);
int __fastcall GetFilenames(TStrings *names, AnsiString &pathname, int attrib=faAnyFile);
AnsiString __fastcall AddBackslash(AnsiString path);
AnsiString __fastcall RemoveBackslash(AnsiString path);
HRESULT CreateLink(AnsiString TargetPath, AnsiString LinkPath, AnsiString IconPath,
   AnsiString Description, AnsiString Params);
bool __fastcall RegKeyExists(AnsiString &Key);
void __fastcall BufSaveToFileBak(byte* buffer, int length, AnsiString &docname, int bakcopies);
void __fastcall SaveToFileBak(TStrings *Document, AnsiString &FileName, int bakcopies);
void __fastcall FileSaveToFileBak(AnsiString &TmpFile, AnsiString &FileName, int bakcopies);
AnsiString __fastcall bak(AnsiString &name, int baknumber);
bool __fastcall CreateEmptyFile(const AnsiString &FileName);

extern bool DoMyBeep;
extern bool PGP6updated;
extern TStringList *InfoDlgsValues;
extern UINT MsgOneInstance;
//---------------------------------------------------------------------------
#endif
