# ---------------------------------------------------------------------------
VERSION = BCB.01
# ---------------------------------------------------------------------------
!ifndef BCB
BCB = $(MAKEDIR)\..
!endif
# ---------------------------------------------------------------------------
PROJECT = HCW.exe
OBJFILES = HCW.obj HashCashDlgs.obj libhc.obj libsha1.obj random.obj sha1.obj \
   timer.obj utct.obj Global.obj MsgBoxDlgs.obj HashCashThrds.obj \
   HashTimeThrds.obj AboutDlgs.obj HCWVer.obj HelpDlgs.obj LogDlgs.obj \
   fmxutils.obj SpendDlgs2.obj HashCashChks.obj View.obj EditDlgs.obj \
   ImportDlgs.obj ExportDlgs.obj
RESFILES = HCW.res
RESDEPEN = $(RESFILES) HashCashDlgs.dfm MsgBoxDlgs.dfm AboutDlgs.dfm \
   HelpDlgs.dfm LogDlgs.dfm SpendDlgs2.dfm View.dfm EditDlgs.dfm ImportDlgs.dfm \
   ExportDlgs.dfm
LIBFILES = 
DEFFILE =
# ---------------------------------------------------------------------------
CFLAG1 = -Od -Hc -w -k -r- -y -v -vi- -c -a4 -b- -w-par -w-inl -Vx -Ve -x
CFLAG2 = -DWIN32 \
   -I$(BCB)\projects\qs1\qs;$(BCB)\projects\qs1\qsshared;.\;$(BCB)\3rdparty\explbtn;$(BCB)\include;$(BCB)\include\vcl \
   -H=$(BCB)\lib\vcld.csm 
PFLAGS = -AWinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE \
   -DWIN32 \
   -U$(BCB)\projects\qs1\qs;$(BCB)\projects\qs1\qsshared;.\;$(BCB)\3rdparty\explbtn;$(BCB)\lib\obj;$(BCB)\lib \
   -I$(BCB)\projects\qs1\qs;$(BCB)\projects\qs1\qsshared;.\;$(BCB)\3rdparty\explbtn;$(BCB)\include;$(BCB)\include\vcl \
   -v -$Y -$W -$O- -JPHNV -M
RFLAGS = -DWIN32 \
   -i$(BCB)\projects\qs1\qs;$(BCB)\projects\qs1\qsshared;.\;$(BCB)\3rdparty\explbtn;$(BCB)\include;$(BCB)\include\vcl 
LFLAGS = -L$(BCB)\projects\qs1\qs;$(BCB)\projects\qs1\qsshared;.\;$(BCB)\3rdparty\explbtn;$(BCB)\lib\obj;$(BCB)\lib \
   -aa -Tpe -x -v -V4.0
IFLAGS =
LINKER = ilink32
# ---------------------------------------------------------------------------
ALLOBJ = c0w32.obj $(OBJFILES)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) vcl.lib import32.lib cp32mt.lib
# ---------------------------------------------------------------------------
.autodepend

$(PROJECT): $(OBJFILES) $(RESDEPEN) $(DEFFILE)
    $(BCB)\BIN\$(LINKER) @&&!
    $(LFLAGS) +
    $(ALLOBJ), +
    $(PROJECT),, +
    $(ALLLIB), +
    $(DEFFILE), +
    $(ALLRES)
!

.pas.hpp:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.pas.obj:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.cpp.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $*

.c.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $**

.rc.res:
    $(BCB)\BIN\brcc32 $(RFLAGS) $<
#-----------------------------------------------------------------------------

