//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "HashCashThrds.h"
#include "HashCash.h"
//---------------------------------------------------------------------------
int __fastcall DoMintToken(int timewidth,int Bits, AnsiString &Resource,
   time_t Validity_Period,long Anon_Period,TThreadPriority Priority,AnsiString &Token,
      long *Anon_Random,double *Tries_Taken,BOOL *Cancel)
{
   THashCashThread *HCThread = new THashCashThread(true);
   HCThread->timewidth = timewidth;
   HCThread->validity_period = Validity_Period;
   HCThread->anon_period = Anon_Period;
   HCThread->anon_random = Anon_Random;
   HCThread->tries_taken = Tries_Taken;
   HCThread->resource = Resource;
   HCThread->Priority = Priority;
   HCThread->cancel = Cancel;
   HCThread->bits = Bits;
   HCThread->Resume();
   while (HCThread->isworking && !Application->Terminated)
      Application->ProcessMessages();
   int retvalue = HCThread->returnvalue;
   Token = HCThread->token;
   delete HCThread;
   Sleep(100);
   return retvalue;
}
//---------------------------------------------------------------------------
__fastcall THashCashThread::THashCashThread(BOOL CreateSuspended)
	: TThread(CreateSuspended)
{
   isworking = true;
   cancel = NULL;
}
//---------------------------------------------------------------------------
void __fastcall THashCashThread::Execute()
{
   char tok[MAX_TOK+1] = { 0 };
   time_t nowtime=local_to_utctime(time(NULL));
   returnvalue = hashcash_mint(nowtime,timewidth,resource.c_str(),bits,validity_period,
      anon_period,tok,MAX_TOK+1,anon_random,tries_taken,(bool*)cancel);
   if (returnvalue==HASHCASH_OK) token = AnsiString(tok);
   isworking = false;
}
//---------------------------------------------------------------------------
