//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "LogDlgs.h"
#include "Global.h"
#include "Fmxutils.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TLogDlg *LogDlg;
//---------------------------------------------------------------------------
bool __fastcall ViewMintLog(TForm *Owner, TColor txtColor)
{
   LogDlg = new TLogDlg(Owner);
   LogDlg->Memo1->Font->Color = txtColor;
   AnsiString fname = ChangeFileExt(AppExeName,".log");
   if (FileExists(fname))
   {
      LogDlg->Memo1->Lines->LoadFromFile(fname);
      LogDlg->Caption = "HashCash Log from "+
         FormatDateTime("dddd, mmmm d yyy, h:mm:ss am/pm",FileDateTime(fname));
   }
   else LogDlg->Memo1->Clear();
   LogDlg->ShowModal();
   delete LogDlg;
   return true;
}
//---------------------------------------------------------------------------
__fastcall TLogDlg::TLogDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner); Top += 7;
   Memo1->Align = alClient;
}
//---------------------------------------------------------------------------
